# Stork (pleroma-bot)


![Stork](/pleroma-bot/images/logo.png)

Mirror your favorite Twitter accounts in the Fediverse, so you can follow their updates from the comfort of your favorite instance. Or migrate your own to the Fediverse using a Twitter [archive](https://twitter.com/settings/your_twitter_data).

[![Build Status](https://travis-ci.com/robertoszek/pleroma-bot.svg?branch=master)](https://app.travis-ci.com/github/robertoszek/pleroma-bot)
[![Version](https://img.shields.io/pypi/v/pleroma-bot.svg)](https://pypi.org/project/pleroma-bot/)
[![codecov](https://codecov.io/gh/robertoszek/pleroma-bot/branch/master/graph/badge.svg?token=0c4Gzv4HjC)](https://codecov.io/gh/robertoszek/pleroma-bot)
[![Python 3.6](https://img.shields.io/badge/python-3.6+-blue.svg)](https://www.python.org/downloads/release/python-360/)
[![License](https://img.shields.io/github/license/robertoszek/pleroma-bot)](https://github.com/robertoszek/pleroma-bot/blob/master/LICENSE.md)


[:material-file-document-multiple-outline:  Get started](/pleroma-bot/gettingstarted/installation/){: .md-button } [:material-download-outline: Download](https://github.com/robertoszek/pleroma-bot/releases/latest){: .md-button } [:material-arch: AUR (Arch)](https://aur.archlinux.org/packages/python-pleroma-bot){: .md-button }

## Features
* [x] Can parse a Twitter [archive](https://twitter.com/settings/your_twitter_data), moving all your tweets to the Fediverse
* [x] Retrieves **tweets** and posts them on the Fediverse account
    * [x] Can filter out RTs
    * [x] Can filter out replies
* [x] Media retrieval and upload of multiple **attachments**
    * [x] :material-video: Video
    * [x] :material-file-image: Images
    * [x] :material-animation-play: Animated GIFs 
    * [x] :material-ballot-outline: Polls
* [x] Update Fediverse **profile info** based on the Twitter account
    * [x] *Display name*
    * [x] *Profile picture*
    * [x] *Banner image*
    * [x] *Bio text*
* [x] Customize Fediverse account's **metadata fields** (e.g. point to the original Twitter account)

## Funding
If you feel like supporting the creator or buying him a beer, you can donate through Ko-fi or Liberapay

[![Donate using Liberapay](https://liberapay.com/assets/widgets/donate.svg)](https://liberapay.com/robertoszek/donate) [![ko-fi](https://ko-fi.com/img/githubbutton_sm.svg)](https://ko-fi.com/robertoszek)

